Option Explicit On 
Option Strict On
Option Compare Binary

' <remarks>
'   Reprsentiert ein Objekt fr ein Rucksackproblem.
' </remarks>
Public Class KnapsackObject
    Private m_dblCost As Double
    Private m_dblWeight As Double
    Private m_objId As Object

    ' <summary>
    '   Erstellt eine neue Instanz der Klasse und 
    '   weist den Eigenschaften die in den Parametern
    '   angebenen Werte zu.
    ' </summary>
    ' <param name="dblCost">Kosten des Objekts.</param>
    ' <param name="dblWeight">Gewicht des Objekts.</param>
    ' <param name="objId">ID des Objekts.</param>
    Public Sub New( _
      ByVal dblCost As Double, _
      ByVal dblWeight As Double, _
      ByVal objId As Object)
        Me.Cost = dblCost
        Me.Weight = dblWeight
        Me.Id = objId
    End Sub

    ' <summary>
    '   Gibt die Kosten des Objekts an oder gibt sie zurck.
    ' </summary>
    ' <value>Kosten des Objekts.</value>
    Public Property Cost() As Double
        Get
            Return m_dblCost
        End Get
        Set(ByVal Value As Double)
            m_dblCost = Value
        End Set
    End Property

    ' <summary>
    '   Gibt das Gewicht des Objekts an oder gibt es zurck.
    ' </summary>
    ' <value>Gewicht des Objekts.</value>
    Public Property Weight() As Double
        Get
            Return m_dblWeight
        End Get
        Set(ByVal Value As Double)
            m_dblWeight = Value
        End Set
    End Property

    ' <summary>
    '   Gibt ein Objekt an oder zurck, das das 
    '   Element eindeutig identifiziert.
    ' </summary>
    ' <value>ID des Objekts.</value>
    Public Property Id() As Object
        Get
            Return m_objId
        End Get
        Set(ByVal Value As Object)
            m_objId = Value
        End Set
    End Property

    ' <summary>
    '   Gibt einen String zurck, der die Objektinstanz reprsentiert.
    ' </summary>
    ' <returns>String, der die Objektinstanz reprsentiert.</returns>
    Public Overrides Function ToString() As String
        Return "ID = """ & Me.Id.ToString() & """, _Cost = " & _
          Me.Cost.ToString() & _
          ", Weight = " & Me.Weight.ToString()
    End Function
End Class