Option Explicit On 
Option Strict On
Option Compare Binary

Imports Microsoft.VisualBasic

' <remarks>
'   Reprsentiert eine Lsung eines Rucksackproblems.
' </remarks>
Public Class KnapsackSolution
    Private m_dblTotalCost As Double
    Private m_akobjSelectedObjects() As KnapsackObject

    ' <summary>
    '   Gibt die Gesamtkosten der Objekte der Lsung 
    '   an oder gibt sie zurck.
    ' </summary>
    ' <value>Gesamtkosten der Objekte der Lsung.</value>
    Public Property TotalCost() As Double
        Get
            Return m_dblTotalCost
        End Get
        Set(ByVal Value As Double)
            m_dblTotalCost = Value
        End Set
    End Property

    ' <summary>
    '   Gibt ein Array von <c>KnapsackObject</c>-Objekten 
    '   an oder zurck, die eine Lsung eines
    '   Rucksackproblems darstellen.
    ' </summary>
    ' <value>Array von <c>KnapsackObject</c>-Objekten, die 
    '  eine Lsung eines Rucksackproblems darstellen.</value>
    Public Property SelectedObjects() As KnapsackObject()
        Get
            Return m_akobjSelectedObjects
        End Get
        Set(ByVal Value() As KnapsackObject)
            m_akobjSelectedObjects = Value
        End Set
    End Property

    ' <summary>
    '   Gibt einen String zurck, der die Objektinstanz reprsentiert.
    ' </summary>
    ' <returns>String, der die Objektinstanz reprsentiert.</returns>
    Public Overloads Function ToString() As String
        Dim s As String = _
            "TotalCost = " & Me.TotalCost.ToString() & _
            ControlChars.NewLine & _
            "SelectedObjects = {"
        If Me.SelectedObjects.Length > 0 Then
            s &= _
                ControlChars.NewLine & _
                "    (" & Me.SelectedObjects(0).ToString() & ")"
        End If
        If Me.SelectedObjects.Length > 1 Then
            Dim i As Integer
            For i = 1 To Me.SelectedObjects.Length - 1
                s &= _
                    "," & ControlChars.NewLine & _
                    "    (" & Me.SelectedObjects(i).ToString() & ")"
            Next i
        End If
        Return _
            s & ControlChars.NewLine & _
            "}"
    End Function
End Class